//////////////////////////////////////////
//    Network Security Analysis Tool    //
//          (c) 1999 by Mixter          //
//////////////////////////////////////////

// vulnerable cgi lists
// based off webscan.c by Mixter

// parts from: whisker (c) .rain.forest.puppy.
// cgiscan (c) [CKS & Fdisk], VoidEye scanner,
// httpver (c) Shok

// currently 181 confirmedly vulnerable CGIs, p00r e-commerce ;x

const char *www_extensions[] =
{
"/_vti_bin/shtml.dll",				// frontpage
"/_vti_bin/shtml.exe",
"/_vti_inf.html",
"/_vti_pvt/administrators.pwd",
"/_vti_pvt/authors.pwd",
"/_vti_pvt/service.pwd",
"/_vti_pvt/service.grp",
"/_vti_pvt/users.pwd",
"/cfappman/index.cfm",				// coldfusion
"/cfdocs/cfmlsyntaxcheck.cfm",
"/cfdocs/exampleapp/docs/sourcewindow.cfm",
"/cfdocs/examples/cvbeans/beaninfo.cfm",
"/cfdocs/examples/httpclient/mainframeset.cfm",
"/cfdocs/examples/parks/detail.cfm",
"/cfdocs/expeval/displayopenedfile.cfm",
"/cfdocs/expeval/exprcalc.cfm",
"/cfdocs/expeval/openfile.cfm",
"/cfdocs/expeval/sendmail.cfm",
"/cfdocs/snippets/evaluate.cfm",
"/cfdocs/snippets/fileexists.cfm",
"/cfdocs/snippets/gettempdirectory.cfm",
"/cfdocs/snippets/viewexample.cfm",
"/cgi-bin/search.cgi",				// misc stuff
"/cgi-bin/bigconf.cgi",
"/cgi-bin/alibaba.pl",
"/cgi-bin/tst.bat",
"/cgi-bin/cachemgr.cgi",
"EOF"
};

const char *www_winnt[] =
{
"/....../autoexec.bat",
"/?PageServices",
"/_AuthChangeUrl?",
"/adsamples/config/site.csc",
"/cgi-dos/args.bat",
"/cgi-dos/args.cmd",
"/cgi-shl/win-c-sample.exe",
"/cgi-win/uploader.exe",
"/domcfg.nsf/?open",
"/iisadmpwd/achg.htr",				// admin path
"/iisadmpwd/aexp.htr",
"/iisadmpwd/aexp2.htr",
"/iisadmpwd/aexp2b.htr",
"/iisadmpwd/aexp3.htr",
"/iisadmpwd/aexp4.htr",
"/iisadmpwd/aexp4b.htr",
"/iisadmpwd/anot.htr",
"/iisadmpwd/anot3.htr",
"/msadc/Samples/SELECTOR/showcode.asp",		// evil odbc stuff
"/msadc/msadcs.dll",
"/msads/samples/selector/showcode.asp",
"/scripts/CGImail.exe",
"/scripts/convert.bas",
"/scripts/cpshost.dll",
"/scripts/fpcount.exe",
"/scripts/iisadmin/bdir.htr",
"/scripts/proxy/w3proxy.dll",
"/scripts/samples/ctguestb.idc",
"/scripts/samples/details.idc",
"/scripts/tools/getdrvs.exe",
"/scripts/tools/newdsn.exe",
"/search97.vts",
"/session/adminlogin?RCpage=/sysadmin/index.stm",
"/~root"
"/iissamples/exair/howitworks/codebrws.asp",		// DoS stuff
"/iissamples/sdk/asp/docs/codebrws.asp",
"/cgi-bin/visadmin.exe",
"/scripts/../../cmd.exe",
"/secure/.htaccess",
"/secure/.wwwacl",
"EOF"
};

const char *www_cgibin[] =
{
"/cgi-bin/AT-admin.cgi",				// alot of.. stuff
"/cgi-bin/AnyForm",
"/cgi-bin/AnyForm2",
"/cgi-bin/Count.cgi",
"/cgi-bin/LWGate",
"/cgi-bin/LWGate.cgi",
"/cgi-bin/MachineInfo",
"/cgi-bin/aglimpse",
"/cgi-bin/archie",
"/cgi-bin/architext_query.pl",
"/cgi-bin/ash",
"/cgi-bin/bash",
"/cgi-bin/bb-hist.sh",
"/cgi-bin/bnbform",
"/cgi-bin/bnbform.cgi",
"/cgi-bin/calendar",
"/cgi-bin/campas",
"/cgi-bin/carbo.dll",
"/cgi-bin/cgimail.exe",
"/cgi-bin/cgiwrap",
"/cgi-bin/classified.cgi",
"/cgi-bin/classifieds",
"/cgi-bin/classifieds.cgi",
"/cgi-bin/count.cgi",
"/cgi-bin/csh",
"/cgi-bin/date",
"/cgi-bin/day5datacopier.cgi",
"/cgi-bin/day5datanotifier.cgi",
"/cgi-bin/download.cgi",
"/cgi-bin/dumpenv.pl",
"/cgi-bin/edit.pl",
"/cgi-bin/environ.cgi",
"/cgi-bin/faxsurvey",
"/cgi-bin/filemail",
"/cgi-bin/filemail.pl",
"/cgi-bin/files.pl",
"/cgi-bin/finger",
"/cgi-bin/finger.cgi",
"/cgi-bin/finger.pl",
"/cgi-bin/flexform",
"/cgi-bin/flexform.cgi",
"/cgi-bin/formmail.pl",
"/cgi-bin/fortune",
"/cgi-bin/glimpse",
"/cgi-bin/guestbook.cgi",
"/cgi-bin/handler",
"/cgi-bin/handler.cgi",
"/cgi-bin/htmlscript",
"/cgi-bin/info2www",
"/cgi-bin/jj",
"/cgi-bin/ksh",
"/cgi-bin/lwgate",
"/cgi-bin/lwgate.cgi",
"/cgi-bin/mail",
"/cgi-bin/maillist.pl",
"/cgi-bin/man.sh",
"/cgi-bin/mlog.phtml",
"/cgi-bin/mylog.phtml",
"/cgi-bin/nlog-smb.pl",
"/cgi-bin/nph-error.pl",
"/cgi-bin/nph-publish",
"/cgi-bin/nph-test-cgi",
"/cgi-bin/passwd",
"/cgi-bin/passwd.txt",
"/cgi-bin/password",
"/cgi-bin/password.txt",
"/cgi-bin/perl",
"/cgi-bin/perl.exe",
"/cgi-bin/perlshop.cgi",
"/cgi-bin/pfdispaly.cgi",
"/cgi-bin/phf",
"/cgi-bin/phf.cgi",
"/cgi-bin/phf.pp",
"/cgi-bin/php",
"/cgi-bin/php.cgi",
"/cgi-bin/post-query",
"/cgi-bin/ppdscgi.exe",
"/cgi-bin/query",
"/cgi-bin/redirect",
"/cgi-bin/rguest.exe",
"/cgi-bin/rksh",
"/cgi-bin/rsh",
"/cgi-bin/rwwwshell.pl",
"/cgi-bin/sam._",
"/cgi-bin/search97.vts",
"/cgi-bin/sendform.cgi",
"/cgi-bin/sh",
"/cgi-bin/snorkerz.bat",
"/cgi-bin/snorkerz.cmd",
"/cgi-bin/survey",
"/cgi-bin/survey.cgi",
"/cgi-bin/tcsh",
"/cgi-bin/test-cgi",
"/cgi-bin/test-cgi.tcl",
"/cgi-bin/test-env",
"/cgi-bin/textcounter.pl",
"/cgi-bin/unlg1.1",
"/cgi-bin/upload.pl",
"/cgi-bin/uptime",
"/cgi-bin/view-source",
"/cgi-bin/w3-msql",
"/cgi-bin/w3tvars.pm",
"/cgi-bin/wais.pl",
"/cgi-bin/webdist.cgi",
"/cgi-bin/webgais",
"/cgi-bin/webmap.cgi",
"/cgi-bin/websendmail",
"/cgi-bin/wguest.exe",
"/cgi-bin/whois_raw.cgi",
"/cgi-bin/wrap",
"/cgi-bin/www-sql",
"/cgi-bin/wwwadmin.pl",
"/cgi-bin/wwwboard.pl",
"/cgi-bin/zsh",
"EOF"
};
