//////////////////////////////////////////
//    Network Security Analysis Tool    //
//          (c) 1999 by Mixter          //
//                                      //
//         options and recovery         //
//////////////////////////////////////////

#ifndef PROGRESS_H
#define PROGRESS_H
#pragma interface "progress"
#include "nsat.h"

#define SMALLB 256

class ProgressIndicator
{
 public:
  int tstamp;			/* time()... */
  int timeout;
  int pingonly;			/* option: dont scan if icmp test fails */
  int verbose;			/* report a lot */
  int stealth;			/* hide a lot */
  int idle;			/* sysidle time */
  int fscan;			/* file scan (1) or range scan (0) */
  int maxproc;
  int maxlife;
  long ipcur;			/* current ip */
  long ipend;			/* last ip */
  long fpos;			/* ftell()... */
  char *fname;
  ProgressIndicator ();
  ~ProgressIndicator ();
  void update (long p);
  int restore (void);
  int store (void);
  void status (void);
};

#endif
